        function [ T1,M0,Rsq,M0err,T1err ] = T1fit_w_stats( TR, SI )
        
        % Authors Richard Foster, Robin Damion 2017
        
        %UNTITLED Summary of this function goes here
        %   Detailed explanation goes here

            [TRmaxvalue, index] = max(TR);
            M0initial = SI(index);


            x0 = [M0initial;1.0];         % Mo, T1
            options = optimset('algorithm','levenberg-marquardt','TolFun',1e-6, 'TolX',1e-6,'MaxFunEvals',1e7,'MaxIter',1e7);
            %options=optimset('TolFun',1e-6,'TolX',1e-6,'MaxFunEvals',1e7,'MaxIter',1e7);
            %lb = [0.0; 1e-6];
            %ub = [1e15; 10];
            %[x,resnorm,residual,exitflag] = lsqcurvefit(@Sat_rec,x0,TR,SI,lb,ub,options);
            [x,resnorm,residual,exitflag,output,lambda,J] = lsqcurvefit(@Sat_rec,x0,TR,SI,[],[],options);
            M0 = x(1);
            T1 = x(2);

            ybar = mean(SI);
            ypredicted = Sat_rec(x,TR);
            SSres = sum((SI-ypredicted).^2);
            SStot = sum((SI-ybar).^2);
            Rsq = 1-(SSres/SStot);
            %stderr = (sqrt(SSres/(numel(SI)-2)));

            mse = sum(abs(residual).^2)/(size(J,1)-size(J,2));
        [Q,R] = qr(J,0);
        Rinv = inv(R);
        Sigma = Rinv*Rinv'*mse;
        errors = sqrt(diag(Sigma));
        stderr = full(errors);
        M0err=stderr(1);
        T1err=stderr(2);


        end

